#pragma GCC optimize ("O3")
#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

string nez[100002];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    string now,a;
    long long n,po;
    cin>>now>>n;
    po=now.size();

    for(int i=0;i<n;i++)cin>>nez[i];
    bool yes=false;
    for(int i=0;i<now.size();i++){
        yes=false;
        for(int j=0;j<n && yes==false;j++){
            a=now.substr(i,nez[j].size());
            //cout<<a<<endl;
            if(a==nez[j]){
                now.erase(i,a.size());
                yes=true;
            }
        }
        if(yes==true && po<50000)i=0;
        else if(yes==true){
            if(po<70000){
                if(i>=10000)i-=10000;
                else i=0;
            }else i-=2;
        }

    }
    cout<<now<<endl;

    return 0;
}

